class GameplatformController < ApplicationController

  # Make sure that a user logs in before doing any action here
  before_filter :authorize

  def index
    list
    render :action => 'list'
  end

  # GETs should be safe (see http://www.w3.org/2001/tag/doc/whenToUseGet.html)
  verify :method => :post, :only => [ :destroy, :create, :update ],
         :redirect_to => { :action => :list }

  def list
    @gameplatform_pages, @gameplatforms = paginate :gameplatforms, :per_page => 10
  end

  def show
    @gameplatform = Gameplatform.find(params[:id])
  end

  def new
    @gameplatform = Gameplatform.new
  end

  def create
    @gameplatform = Gameplatform.new(params[:gameplatform])
    if @gameplatform.save
      flash[:notice] = 'Gameplatform was successfully created.'
      redirect_to :action => 'list'
    else
      render :action => 'new'
    end
  end

  def edit
    @gameplatform = Gameplatform.find(params[:id])
  end

  def update
    @gameplatform = Gameplatform.find(params[:id])
    if @gameplatform.update_attributes(params[:gameplatform])
      flash[:notice] = 'Gameplatform was successfully updated.'
      redirect_to :action => 'show', :id => @gameplatform
    else
      render :action => 'edit'
    end
  end

  def destroy
    Gameplatform.find(params[:id]).destroy
    redirect_to :action => 'list'
  end
end
