class MediaController < ApplicationController

  # Make sure that a user logs in before doing any action here
  before_filter :authorize

  def index
    list
    render :action => 'list'
  end

  # GETs should be safe (see http://www.w3.org/2001/tag/doc/whenToUseGet.html)
  verify :method => :post, :only => [ :destroy, :create, :update ],
         :redirect_to => { :action => :list }

  def list
    @media_pages, @medias = paginate :medias, :per_page => 10
  end

  def show
    @media = Media.find(params[:id])
  end

  def new
    @media = Media.new
  end

  def create
    @media = Media.new(params[:media])
    if @media.save
      flash[:notice] = 'Media was successfully created.'
      redirect_to :action => 'list'
    else
      render :action => 'new'
    end
  end

  def edit
    @media = Media.find(params[:id])
  end

  def update
    @media = Media.find(params[:id])
    if @media.update_attributes(params[:media])
      flash[:notice] = 'Media was successfully updated.'
      redirect_to :action => 'show', :id => @media
    else
      render :action => 'edit'
    end
  end

  def destroy
    Media.find(params[:id]).destroy
    redirect_to :action => 'list'
  end
end
